#/bin/bash 

set -e
set -x

main()
{

	# update submodules
	git submodule sync --recursive
	git submodule update --recursive --init

	# install IDA
	cicd_setup_module_dependency allzp/idapro71.git idapro71
	export IDAROOT=$CICD_MODULE_WORK_DIR/idapro71
	cicd_setup_module_dependency allzp/idapro71_sdk.git idapro71_sdk
	export IDASDK=$CICD_MODULE_WORK_DIR/idapro71_sdk


	# gather info for debugging later, probably not necessary 
	pwd
	hostname
	whoami
	env|grep "^CICD"

	local orig_dir=$(pwd)

	# puts peasoup_umbrella (and all submodules) in CICD_MODULE_WORK_DIR
	cicd_setup_module_dependency opensrc/zipr.git cicd_stars_umbrella

	# puts the version of zipr to test in cicd_stars_umbrella/SMPStaticAnalyzer.
	cicd_put_module_in_tree cicd_stars_umbrella/SMPStaticAnalyzer

	# Build peasoup_umbrella as cicd_stars_umbrella
	cd $CICD_MODULE_WORK_DIR/cicd_stars_umbrella
	
	source set_env_vars
	sudo ./get-peasoup-packages.sh all
	./build-all.sh
	dropdb $PGDATABASE 2>/dev/null || true ; ./postgres_setup.sh

	cd $orig_dir
}

main "$@"
