#include <map>

#include "interfaces/STARSTypes.h"
#include "interfaces/SMPDBInterface.h"
#include "interfaces/abstract/STARSInstruction.h"


// declare global static data for STARS_InstructionID_t class
std::map<STARS_ea_t, const STARS_Instruction_t*> STARS_InstructionID_t::id_to_insn_map;
uint64_t STARS_Instruction_t::objects_created=0;
uint64_t STARS_Instruction_t::objects_destroyed=0;


bool STARS_Instruction_t::OpcodeDefaultsTo64BitOperands(void) 
{
	bool Default64;
	switch (this->GetIDAOpcode()) 
	{
		// use ss
		case STARS_NN_pop:
		case STARS_NN_popf:
		case STARS_NN_popfq:
		case STARS_NN_push:
		case STARS_NN_pushf:
		case STARS_NN_pushfq:
		case STARS_NN_retn:
		case STARS_NN_retf:
		case STARS_NN_retnq:
		case STARS_NN_retfq:
		case STARS_NN_call:
		case STARS_NN_callfi:
		case STARS_NN_callni:
		case STARS_NN_enter:
		case STARS_NN_enterq:
		case STARS_NN_leave:
		case STARS_NN_leaveq:

		// near branches
		case STARS_NN_ja:
		case STARS_NN_jae:
		case STARS_NN_jb:
		case STARS_NN_jbe:
		case STARS_NN_jc:
		case STARS_NN_je:
		case STARS_NN_jg:
		case STARS_NN_jge:
		case STARS_NN_jl:
		case STARS_NN_jle:
		case STARS_NN_jna:
		case STARS_NN_jnae:
		case STARS_NN_jnb:
		case STARS_NN_jnbe:
		case STARS_NN_jnc:
		case STARS_NN_jne:
		case STARS_NN_jng:
		case STARS_NN_jnge:
		case STARS_NN_jnl:
		case STARS_NN_jnle:
		case STARS_NN_jno:
		case STARS_NN_jnp:
		case STARS_NN_jns:
		case STARS_NN_jnz:
		case STARS_NN_jo:
		case STARS_NN_jp:
		case STARS_NN_jpe:
		case STARS_NN_jpo:
		case STARS_NN_js:
		case STARS_NN_jz:
		case STARS_NN_jcxz:
		case STARS_NN_jecxz:
		case STARS_NN_jrcxz:
		case STARS_NN_jmp:
		case STARS_NN_jmpni:
		case STARS_NN_jmpshort:
		case STARS_NN_loop:
		case STARS_NN_loopq:
		case STARS_NN_loope:
		case STARS_NN_loopqe:
		case STARS_NN_loopne:
		case STARS_NN_loopqne:
			Default64 = true;
			break;
		default:
			Default64 = false;
			break;
	}
	return Default64;
} // end of STARS_Instruction_t::OpcodeDefaultsTo64BitOperands()

STARS_InstructionID_Set_t STARS_Instruction_t::GetTargetedInstructionIDs(bool &success) {
	success = false; 
	return STARS_InstructionID_Set_t(); 
}

// Analyze the indirect jump at IndirJumpInst, put switch table info in TableInfo if available, return false otherwise.
// Note: The TableInfo.FollowNodeNum field must be determined by later analysis.
bool STARS_Instruction_t::AnalyzeSwitchStatement(SMPInstr *IndirJumpInst, struct SwitchTableInfo &TableInfo) { 
	return false; 
}


	
