#!/bin/bash

fails=0 
skips=0 
processed=0 
failbench="" 

PSEXES=`ls *exe`

for name in $PSEXES ; do
	processed=$(expr $processed + 1);
	$SMPSA_HOME/tests/scripts/UpdateSMP64.sh $name
	if [ $? -ne 0 ] ; then
		fails=$(expr $fails + 1);
		failbench="$failbench $name"
	fi
done

echo "------------------------------------------------" |tee regress64.log
echo "Skips recorded: $skips" |tee -a regress64.log

if [ $fails -eq 0 ]; then
	echo "SUCCESS: No failures found!" |tee -a regress64.log
	echo "Tests Processed: $processed" |tee -a regress64.log
	echo "------------------------------------------------" |tee -a regress64.log
	exit 0
else
	echo "FAILURES FOUND ************************* " |tee -a regress64.log
	echo "Tests Processed: $processed" |tee -a regress64.log
	echo "Number of failures: $fails" |tee -a regress64.log
	echo "Failing benchmarks: $failbench" |tee -a regress64.log
	echo "------------------------------------------------" |tee -a regress64.log
	exit 1
fi

